<script setup lang="ts">
import { ref } from 'vue'
import { useUserStore } from '../stores/user'
import { requiredRule } from '@/utils/rules'
import { computed } from 'vue'
import { onMounted } from 'vue'
import { onUnmounted } from 'vue'

const store = useUserStore()
const formValid = ref()
const isCustomer = ref<boolean>()
const tempSelectOwner = ref()

onMounted(() => {
  store.fetchAvailableSelect()
})

const listTitle = computed(() => {
  if (isCustomer.value) {
    return 'name'
  }
  return 'fullName'
})

const listSelect = computed(() => {
  if (isCustomer.value) {
    return store.getCustomer
  }
  return store.getEmployees
})

onUnmounted(() => {
  store.fetchUsers()
})
</script>

<template>
  <v-dialog v-model="store.formDialog">
    <template #activator="{ props }">
      <v-btn v-bind="props" rounded="pill" flat prepend-icon="mdi-plus" text="New"></v-btn>
    </template>
    <template #default="{ isActive }">
      <v-form v-model="formValid">
        <v-card class="pa-5 mx-auto" width="1024">
          <v-card-title>
            <span class="text-h5">New User</span>
          </v-card-title>
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="6">
                  <v-text-field
                    type="email"
                    v-model="store.userItem.email"
                    label="Email"
                    :rules="[requiredRule]"
                  >
                  </v-text-field>
                </v-col>
                <v-col cols="6">
                  <v-text-field
                    type="password"
                    v-model="store.userItem.password"
                    label="Password"
                    :rules="[requiredRule]"
                  >
                  </v-text-field>
                </v-col>
                <v-col cols="6" class="d-flex justify-center">
                  <v-switch
                    v-model="isCustomer"
                    color="green"
                    label="Customer User"
                    @update:model-value="
                      (v) => {
                        store.userItem.cusId = undefined
                        store.userItem.empId = undefined
                        tempSelectOwner = undefined
                        if (v) {
                          store.userItem.roleName = 'customer'
                        } else {
                          store.userItem.roleName = ''
                        }
                      }
                    "
                  ></v-switch>
                </v-col>
                <v-col cols="6">
                  <v-autocomplete
                    v-model="tempSelectOwner"
                    :rules="[requiredRule]"
                    label="Select the owner"
                    :items="listSelect"
                    :item-title="listTitle"
                    item-value="id"
                    @update:model-value="
                      (v) => {
                        if (isCustomer) {
                          store.userItem.cusId = v
                          store.userItem.empId = undefined
                        } else {
                          store.userItem.empId = v
                          store.userItem.cusId = undefined
                        }
                      }
                    "
                  ></v-autocomplete>
                </v-col>
                <v-col cols="12" v-if="!isCustomer">
                  <v-autocomplete
                    :rules="[requiredRule]"
                    label="Select a role"
                    :items="store.getRoles"
                    item-title="name"
                    @update:model-value="(v) => (store.userItem.roleName = v)"
                  ></v-autocomplete
                ></v-col>
              </v-row>
            </v-container>
          </v-card-text>

          <template #actions>
            <v-row justify="end">
              <v-btn
                type="submit"
                @click="
                  () => {
                    store.resetItem
                    isActive.value = false
                  }
                "
              >
                Cancel
              </v-btn>
              <v-btn @click="store.save()" :disabled="!formValid"> Save </v-btn>
            </v-row>
          </template>
        </v-card>
      </v-form>
    </template>
  </v-dialog>
</template>
